@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo. Error^^! Please do not execute this file alone^^! && echo. && echo. Please press any key to exit. && pause>nul && exit

:doFlashBLPart
    REM This is a discriminant for GPT image.
    set /A A=0
    if exist gpt.bin set /A A+=1
    if exist diskmap.pit set /A A+=1
    if exist PGPT set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo. Fatal Error: Different types GPT image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if %A% EQU 0 (
        echo.
        echo. Warning: GPT image does not exist. Skipping flash...
    )
    REM if %A% EQU 1
    if exist gpt.bin (
        echo.
        echo. ------ Flashing GPT image ------
        %fastboot% -s %serial_number% flash partition gpt.bin
        if !errorlevel! NEQ 0 (
            color fc
            echo. ------------------------------
            echo. Fatal Error: fastboot flash gpt failed^^!
            echo. ------------------------------
            exit /b 1
        )
    )
    if exist diskmap.pit (
        echo.
        echo. ------ Flashing PIT image ------
        %fastboot% -s %serial_number% flash pit diskmap.pit
        if !errorlevel! NEQ 0 (
            color fc
            echo. ------------------------------
            echo. Fatal Error: fastboot flash pit failed^^!
            echo. ------------------------------
            exit /b 1
        )
    )
    if exist PGPT (
        echo.
        echo. ------ Flashing PGPT image ------
        %fastboot% -s %serial_number% flash gpt PGPT
        if !errorlevel! NEQ 0 (
            color fc
            echo. ------------------------------
            echo. Fatal Error: fastboot flash PGPT failed^^!
            echo. ------------------------------
            exit /b 1
        )
    )

    if "%device_has_fwbl1%" EQU "1" (
        REM This is a discriminant for LDFW image.
        set /A A=0
        if exist fwbl1.nbl1.bin set /A A+=1
        if exist fwbl1.img set /A A+=1
        if !A! GTR 1 (
            color fc
            echo.
            echo. Fatal Error: Different types FWBL1 image exists at the same time, this is obviously wrong, please check^^!
            exit /b 1
        )
        if !A! EQU 0 (
            echo.
            echo. Warning: FWBL1 image does not exist, but your device contain this partition, skipping flash...
        )

        if exist fwbl1.nbl1.bin (
            echo.
            echo. ------ Flashing FWBL1 image ------
            %fastboot% -s %serial_number% flash fwbl1 fwbl1.nbl1.bin
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash fwbl1 failed^^!
                echo. ------------------------------
                exit /b 1
            )
        )
        if exist fwbl1.img (
            echo.
            echo. ------ Flashing FWBL1 image ------
            %fastboot% -s %serial_number% flash fwbl1 fwbl1.img
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash fwbl1 failed^^!
                echo. ------------------------------
                exit /b 1
            )
        )
    )

    if "%device_has_ldfw%" EQU "1" (
        REM This is a discriminant for LDFW image.
        set /A A=0
        if exist ldfw.bin set /A A+=1
        if exist ldfw.img set /A A+=1
        if !A! GTR 1 (
            color fc
            echo.
            echo. Fatal Error: Different types LDFW image exists at the same time, this is obviously wrong, please check^^!
            exit /b 1
        )
        if !A! EQU 0 (
            echo.
            echo. Warning: LDFW image does not exist, but your device contain this partition, skipping flash...
        )

        if exist ldfw.bin (
            echo.
            echo. ------ Flashing LDFW image ------
            !fastboot! -s %serial_number% flash ldfw_a ldfw.bin
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash fwbl1_a failed^^!
                echo. ------------------------------
                exit /b 1
            )
            !fastboot! -s %serial_number% flash ldfw_b ldfw.bin
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash fwbl1_b failed^^!
                echo. ------------------------------
                exit /b 1
            )
        )
        if exist ldfw.img (
            echo.
            echo. ------ Flashing LDFW image ------
            !fastboot! -s %serial_number% flash ldfw_a ldfw.img
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash fwbl1_a failed^^!
                echo. ------------------------------
                exit /b 1
            )
            !fastboot! -s %serial_number% flash ldfw_b ldfw.img
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash fwbl1_b failed^^!
                echo. ------------------------------
                exit /b 1
            )
        )
    )

    if "%device_has_keystorage%" EQU "1" (
        REM This is a discriminant for KeyStorage image.
        set /A A=0
        if exist keystorage.bin set /A A+=1
        if exist keystorage.img set /A A+=1
        if !A! GTR 1 (
            color fc
            echo.
            echo. Fatal Error: Different types KeyStorage image exists at the same time, this is obviously wrong, please check^^!
            exit /b 1
        )
        if !A! EQU 0 (
            echo.
            echo. Warning: LDFW image does not exist, but your device contain this partition, skipping flash...
        )

        if exist keystorage.bin (
            echo.
            echo. ------ Flashing KeyStorage image ------
            %fastboot% -s %serial_number% flash keystorage_a keystorage.bin
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash keystorage_a failed^^!
                echo. ------------------------------
                exit /b 1
            )
            %fastboot% -s %serial_number% flash keystorage_b keystorage.bin
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash keystorage_b failed^^!
                echo. ------------------------------
                exit /b 1
            )
        )
        if exist keystorage.img (
            echo.
            echo. ------ Flashing KeyStorage image ------
            %fastboot% -s %serial_number% flash keystorage_a keystorage.img
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash keystorage_a failed^^!
                echo. ------------------------------
                exit /b 1
            )
            %fastboot% -s %serial_number% flash keystorage_b keystorage.img
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash keystorage_b failed^^!
                echo. ------------------------------
                exit /b 1
            )
        )
    )

    REM This is a discriminant for bootloader image.
    set /A A=0
    if exist motoboot.img set /A A+=1
    if exist bootloader.img set /A A+=1
    if exist bootloader.bin set /A A+=1
    if exist preloader.bin set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo. Fatal Error: Different types Bootloader image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if %A% EQU 0 (
        color fc
        echo.
        echo. Fatal Error: Bootloader image does not exist. This is obviously wrong, please check the firmware location path!
        exit /b 1
    )
    REM if %A% EQU 1
    if exist bootloader.img (
        echo.
        echo. ------ Flashing Bootloader image ------
        %fastboot% -s %serial_number% flash bootloader bootloader.img
        if !errorlevel! NEQ 0 (
            color fc
            echo. ------------------------------
            echo. Fatal Error: fastboot flash bootloader failed^^!
            echo. ------------------------------
            exit /b 1
        )
    ) else (
        if exist motoboot.img (
            echo.
            echo. ------ Flashing Motoboot image ------
            %fastboot% -s %serial_number% flash motoboot motoboot.img
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash motoboot failed^^!
                echo. ------------------------------
                exit /b 1
            )
        )
    )
    if exist bootloader.bin (
        echo.
        echo. ------ Flashing Bootloader image ------
        %fastboot% -s %serial_number% flash bootloader bootloader.bin
        if !errorlevel! NEQ 0 (
            color fc
            echo. ------------------------------
            echo. Fatal Error: fastboot flash bootloader failed^^!
            echo. ------------------------------
            exit /b 1
        )
    )
    if exist preloader.bin (
        echo.
        echo. ------ Flashing Preloader image ------
        %fastboot% -s %serial_number% flash preloader preloader.bin
        if !errorlevel! NEQ 0 (
            color fc
            echo. ------------------------------
            echo. Fatal Error: fastboot flash preloader failed^^!
            echo. ------------------------------
            exit /b 1
        )
    )

    if "%device_has_lk%" EQU "1" (
        if exist lk.img (
            echo.
            echo. ------ Flashing LK image ------
            %fastboot% -s %serial_number% flash lk lk.img
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash lk failed^^!
                echo. ------------------------------
                exit /b 1
            )
        ) else (
            echo.
            echo. Warning: LK image does not exist, but your device contain this partition, skipping flash...
        )
    )
    if "%device_has_tee%" EQU "1" (
        if exist tee.img (
            echo.
            echo. ------ Flashing TEE image ------
            %fastboot% -s %serial_number% flash tee tee.img
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash tee failed^^!
                echo. ------------------------------
                exit /b 1
            )
        ) else (
            echo.
            echo. Warning: TEE image does not exist, but your device contain this partition, skipping flash...
        )
    )
    if "%device_has_mcupm%" EQU "1" (
        if exist mcupm.img (
            echo.
            echo. ------ Flashing MCUPM image ------
            %fastboot% -s %serial_number% flash mcupm%slotsuffix% mcupm.img
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash mcupm failed^^!
                echo. ------------------------------
                exit /b 1
            )
        ) else (
            echo.
            echo. Warning: MCUPM image does not exist, but your device contain this partition, skipping flash...
        )
    )
    if "%device_has_pi_img%" EQU "1" (
        if exist pi_img.img (
            echo.
            echo. ------ Flashing pi_img image ------
            %fastboot% -s %serial_number% flash pi_img%slotsuffix% pi_img.img
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash pi_img failed^^!
                echo. ------------------------------
                exit /b 1
            )
        ) else (
            echo.
            echo. Warning: pi_img image does not exist, but your device contain this partition, skipping flash...
        )
    )
    if "%device_has_dpm%" EQU "1" (
        if exist dpm.img (
            echo.
            echo. ------ Flashing DPM image ------
            %fastboot% -s %serial_number% flash dpm%slotsuffix% dpm.img
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash dpm failed^^!
                echo. ------------------------------
                exit /b 1
            )
        ) else (
            echo.
            echo. Warning: DPM image does not exist, but your device contain this partition, skipping flash...
        )
    )
    if "%device_has_gz%" EQU "1" (
        if exist gz.img (
            echo.
            echo. ------ Flashing GZ image ------
            %fastboot% -s %serial_number% flash gz%slotsuffix% gz.img
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash gz failed^^!
                echo. ------------------------------
                exit /b 1
            )
        ) else (
            echo.
            echo. Warning: GZ image does not exist, but your device contain this partition, skipping flash...
        )
    )
exit /b 0
