@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo. Error^^! Please do not execute this file alone^^! && echo. && echo. Please press any key to exit. && pause>nul && exit

:doFlashCustom
set /A failure_count=0

    if "%device_has_bluetooth%" EQU "1" (
        if exist BTFM.bin (
            echo.
            echo. ------ Flashing Bluetooth image ------
            %fastboot% -s %serial_number% flash bluetooth%slotsuffix% BTFM.bin
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash bluetooth failed^^!
                echo. ------------------------------
            )
        )
    )

    if "%device_has_dsp%" NEQ "1" (
        goto :skipFlashDSP
    )

    REM This is a discriminant for dsp image.
    set /A A=0
    if exist adspso.bin set /A A+=1
    if exist dspso.bin set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo. Fatal Error: adspso.bin and dspso.bin exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )

    REM if %A% EQU 1
    if exist adspso.bin (
        echo.
        echo. ------ Flashing DSP image ------
        %fastboot% -s %serial_number% flash dsp%slotsuffix% adspso.bin
        if !errorlevel! NEQ 0 (
            color f6
            set /A failure_count+=1
            echo. ------------------------------
            echo. Error: fastboot flash dsp failed^^!
            echo. ------------------------------
        )
    ) else (
        if exist dspso.bin (
            echo.
            echo. ------ Flashing DSP image ------
            %fastboot% -s %serial_number% flash dsp%slotsuffix% dspso.bin
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash dsp failed^^!
                echo. ------------------------------
            )
        )
    )
    :skipFlashDSP

    if "%device_has_spmfw%" EQU "1" (
        if exist spmfw.img (
            echo.
            echo. ------ Flashing SPMFW image ------
            %fastboot% -s %serial_number% flash spmfw%slotsuffix% spmfw.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash spmfw failed^^!
                echo. ------------------------------
            )
        )
    )

    if "%device_has_scp%" EQU "1" (
        if exist scp.img (
            echo.
            echo. ------ Flashing SCP image ------
            %fastboot% -s %serial_number% flash scp%slotsuffix% scp.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash scp failed^^!
                echo. ------------------------------
            )
        )
    )

    if "%device_has_sspm%" EQU "1" (
        if exist sspm.img (
            echo.
            echo. ------ Flashing SSPM image ------
            %fastboot% -s %serial_number% flash sspm%slotsuffix% sspm.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash sspm failed^^!
                echo. ------------------------------
            )
        )
    )

    if "%device_has_cam_vpu1%" EQU "1" (
        if exist cam_vpu1.img (
            echo.
            echo. ------ Flashing cam_vpu1 image ------
            %fastboot% -s %serial_number% flash cam_vpu1%slotsuffix% cam_vpu1.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash cam_vpu1 failed^^!
                echo. ------------------------------
            )
        )
        if exist cam_vpu2.img (
            echo.
            echo. ------ Flashing cam_vpu2 image ------
            %fastboot% -s %serial_number% flash cam_vpu2%slotsuffix% cam_vpu2.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash cam_vpu2 failed^^!
                echo. ------------------------------
            )
        )
        if exist cam_vpu3.img (
            echo.
            echo. ------ Flashing cam_vpu3 image ------
            %fastboot% -s %serial_number% flash cam_vpu3%slotsuffix% cam_vpu3.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash cam_vpu3 failed^^!
                echo. ------------------------------
            )
        )
    )

    if exist logo.bin (
        echo.
        echo. ------ Flashing Logo image ------
        %fastboot% -s %serial_number% flash logo%slotsuffix% logo.bin
        if !errorlevel! NEQ 0 (
            color f6
            set /A failure_count+=1
            echo. ------------------------------
            echo. Error: fastboot flash logo failed^^!
            echo. ------------------------------
        )
    )

    if "%device_has_vbmeta%" EQU "1" (
        if exist vbmeta.img (
            echo.
            echo. ------ Flashing VBMeta image ------
            %fastboot% -s %serial_number% flash vbmeta%slotsuffix% vbmeta.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash vbmeta failed^^!
                echo. ------------------------------
            )
        )
    )

    if "%device_has_vbmeta_system%" EQU "1" (
        if exist vbmeta_system.img (
            echo.
            echo. ------ Flashing VBMeta_System image ------
            %fastboot% -s %serial_number% flash vbmeta_system%slotsuffix% vbmeta_system.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash vbmeta_system failed^^!
                echo. ------------------------------
            )
        )
    )

    if exist boot.img (
        echo.
        echo. ------ Flashing Boot image ------
        %fastboot% -s %serial_number% flash boot%slotsuffix% boot.img
        if !errorlevel! NEQ 0 (
            color f6
            set /A failure_count+=1
            echo. ------------------------------
            echo. Error: fastboot flash boot failed^^!
            echo. ------------------------------
        )
    )

    if "%device_has_vendor_boot%" EQU "1" (
        if exist vendor_boot.img (
            echo.
            echo. ------ Flashing Vendor_Boot image ------
            %fastboot% -s %serial_number% flash vendor_boot%slotsuffix% vendor_boot.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash vendor_boot failed^^!
                echo. ------------------------------
            )
        )
    )

    if "%device_has_dtb%" EQU "1" (
        if exist dtb.img (
            echo.
            echo. ------ Flashing DTB image ------
            %fastboot% -s %serial_number% flash dtb%slotsuffix% dtb.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash dtb failed^^!
                echo. ------------------------------
            )
        )
    )

    if "%device_has_dtbo%" EQU "1" (
        if exist dtbo.img (
            echo.
            echo. ------ Flashing DTBO image ------
            %fastboot% -s %serial_number% flash dtbo%slotsuffix% dtbo.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash dtbo failed^^!
                echo. ------------------------------
            )
        )
    )

    if "%device_has_recovery%" EQU "1" (
        if exist recovery.img (
            echo.
            echo. ------ Flashing Recovery image ------
            %fastboot% -s %serial_number% flash recovery%slotsuffix% recovery.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash recovery failed^^!
                echo. ------------------------------
            )
        )
    )

    REM This is a discriminant for modem image.
    set /A A=0
    if exist radio.img set /A A+=1
    if exist NON-HLOS.bin set /A A+=1
    if exist modem.bin set /A A+=1
    if exist md1img.img set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo. Fatal Error: Different types Modem image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )

    REM if %A% EQU 1

    if exist radio.img (
        echo.
        echo. ------ Flashing Radio image ------
        %fastboot% -s %serial_number% flash radio radio.img
        if !errorlevel! NEQ 0 (
            color fc
            echo. ------------------------------
            echo. Fatal Error: fastboot flash radio failed^^!
            echo. ------------------------------
            exit /b 1
        )
    )
    if exist NON-HLOS.bin (
        echo.
        echo. ------ Flashing Modem image ------
        %fastboot% -s %serial_number% flash modem%slotsuffix% NON-HLOS.bin
        if !errorlevel! NEQ 0 (
            color fc
            echo. ------------------------------
            echo. Fatal Error: fastboot flash modem failed^^!
            echo. ------------------------------
            exit /b 1
        )
    )
    if exist modem.bin (
        echo.
        echo. ------ Flashing Modem image ------
        %fastboot% -s %serial_number% flash modem%slotsuffix% modem.bin
        if !errorlevel! NEQ 0 (
            color fc
            echo. ------------------------------
            echo. Fatal Error: fastboot flash modem failed^^!
            echo. ------------------------------
            exit /b 1
        )
    )
    if exist md1img.img (
        echo.
        echo. ------ Flashing Md1img image ------
        %fastboot% -s %serial_number% flash md1img%slotsuffix% md1img.img
        if !errorlevel! NEQ 0 (
            color fc
            echo. ------------------------------
            echo. Fatal Error: fastboot flash md1img failed^^!
            echo. ------------------------------
            exit /b 1
        )
    )

    if "%device_has_fsg%" EQU "1" (
        if exist fsg.mbn (
            echo.
            echo. ------ Flashing FSG image ------
            %fastboot% -s %serial_number% flash fsg%slotsuffix% fsg.mbn
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo. ------------------------------
                echo. Error: fastboot flash fsg failed^^!
                echo. ------------------------------
            )
        )
    )

exit /b 0
